/**
 * $Revision$
 * $Date$
 *
 * Copyright (C) 2006-2007 Jive Software. All rights reserved.
 *
 * This software is published under the terms of the GNU Public License (GPL),
 * a copy of which is included in this distribution.
 */

package org.jivesoftware.openfire.gateway.protocols.msn;

import org.jivesoftware.openfire.gateway.roster.TransportBuddy;
import org.jivesoftware.openfire.gateway.roster.TransportBuddyManager;

import java.util.ArrayList;
import net.sf.jml.MsnContact;
import net.sf.jml.MsnGroup;

/**
 * @author Daniel Henninger
 */
public class MSNBuddy extends TransportBuddy {

    public MSNBuddy(TransportBuddyManager manager, MsnContact msnContact) {
        super(manager, msnContact.getEmail().toString(), msnContact.getFriendlyName(), null);
        ArrayList<String> groups = new ArrayList<String>();
        for (MsnGroup group : msnContact.getBelongGroups()) {
            groups.add(group.getGroupName());
        }
        this.setGroups(groups);
        this.msnContact = msnContact;
        this.setPresenceAndStatus(((MSNTransport)getManager().getSession().getTransport()).convertMSNStatusToXMPP(msnContact.getStatus()), msnContact.getPersonalMessage());
    }

    public MsnContact msnContact = null;

    public MsnContact getMsnContact(){
        return msnContact;
    }

    public void setMsnContact(MsnContact msnContact) {
        this.msnContact = msnContact;
    }

}
