/**
 * $Revision$
 * $Date$
 *
 * Copyright (C) 2006-2007 Jive Software. All rights reserved.
 *
 * This software is published under the terms of the GNU Public License (GPL),
 * a copy of which is included in this distribution.
 */

package org.jivesoftware.openfire.gateway.util;

import java.util.List;

/**
 * A simple class to perform various string related functions.
 *
 * @author Daniel Henninger
 */
public class StringUtils {

    /**
     * Convenience routine to perform a string join for groups in the database.
     * @param array Array of strings to join together.
     * @param delim Delimiter to separate strings with.
     * @return Joined string
     */
    public static String join( List<String> array, String delim ) {
        StringBuffer sb = join(array, delim, new StringBuffer());
        return sb.toString();
    }

    /**
     * Helper function for primary use join function.
     * @param array Array of strings to join together.
     * @param delim Delimiter to separate strings with.
     * @param sb String buffer instance to work from.
     * @return String buffer instance.
     */
    static StringBuffer join( List<String> array, String delim, StringBuffer sb ) {
        Boolean first = true;
        for (String s : array) {
            if (!first) {
                sb.append(delim);
            }
            else {
                first = false;
            }
            sb.append(s);
        }
        return sb;
    }

}
