/**
 * $Revision$
 * $Date$
 *
 * Copyright (C) 2006-2007 Jive Software. All rights reserved.
 *
 * This software is published under the terms of the GNU Public License (GPL),
 * a copy of which is included in this distribution.
 */

package org.jivesoftware.openfire.gateway.web;

import redstone.xmlrpc.XmlRpcServlet;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;

import org.jivesoftware.admin.AuthCheckFilter;
import org.apache.log4j.Logger;

/**
 * @author Daniel Henninger
 */
public class GatewayXMLRPC extends XmlRpcServlet {

    static Logger Log = Logger.getLogger(GatewayXMLRPC.class);

    public void init(ServletConfig servletConfig) {
        try {
            super.init(servletConfig);

            this.getXmlRpcServer().addInvocationHandler("Manager", new XMLRPCConduit());

            AuthCheckFilter.addExclude("gateway/xml-rpc");
        }
        catch (ServletException e) {
            Log.error("Error while loading XMLRPC servlet: ", e);
        }
    }

    public void destroy() {
        AuthCheckFilter.removeExclude("gateway/xml-rpc");
    }

}
