/**
 * $Revision: $
 * $Date: $
 *
 * Copyright (C) 2006 Jive Software. All rights reserved.
 *
 * This software is published under the terms of the GNU Lesser Public License (LGPL),
 * a copy of which is included in this distribution.
 */

package org.jivesoftware.gateway.resource;

import org.jivesoftware.spark.util.log.Log;

import javax.swing.ImageIcon;
import javax.swing.JEditorPane;
import javax.swing.JFrame;
import javax.swing.JScrollPane;

import java.awt.BorderLayout;
import java.io.File;
import java.net.URL;
import java.util.Enumeration;
import java.util.PropertyResourceBundle;
import java.util.ResourceBundle;

public class GatewayImageRes {
    private static PropertyResourceBundle prb;

    public static final String GADUGADU_TRANSPORT_ACTIVE_IMAGE = "GADUGADU_TRANSPORT_ACTIVE_IMAGE";
    public static final String GADUGADU_TRANSPORT_INACTIVE_IMAGE = "GADUGADU_TRANSPORT_INACTIVE_IMAGE";
    public static final String IRC_TRANSPORT_ACTIVE_IMAGE = "IRC_TRANSPORT_ACTIVE_IMAGE";
    public static final String IRC_TRANSPORT_INACTIVE_IMAGE = "IRC_TRANSPORT_INACTIVE_IMAGE";
    public static final String SIMPLE_TRANSPORT_ACTIVE_IMAGE = "SIMPLE_TRANSPORT_ACTIVE_IMAGE";
    public static final String SIMPLE_TRANSPORT_INACTIVE_IMAGE = "SIMPLE_TRANSPORT_INACTIVE_IMAGE";


    static ClassLoader cl = GatewayImageRes.class.getClassLoader();

    static {
        prb = (PropertyResourceBundle)ResourceBundle.getBundle("gateway");
    }

    public static final String getString(String propertyName) {
        return prb.getString(propertyName);
    }

    public static final ImageIcon getImageIcon(String imageName) {
        try {
            final String iconURI = getString(imageName);
            final URL imageURL = cl.getResource(iconURI);
            return new ImageIcon(imageURL);
        }
        catch (Exception ex) {
            System.out.println(imageName + " not found.");
        }
        return null;
    }

    public static final URL getURL(String propertyName) {
        return cl.getResource(getString(propertyName));
    }

    public static void main(String args[]) {
        JFrame frame = new JFrame();
        frame.getContentPane().setLayout(new BorderLayout());

        JEditorPane pane = new JEditorPane();
        frame.getContentPane().add(new JScrollPane(pane));

        StringBuffer buf = new StringBuffer();
        Enumeration enumeration = prb.getKeys();
        while (enumeration.hasMoreElements()) {
            String token = (String)enumeration.nextElement();
            String value = prb.getString(token).toLowerCase();
            if (value.endsWith(".gif") || value.endsWith(".png") || value.endsWith(".jpg") || value.endsWith("jpeg")) {
                getImageIcon(token);
            }
            String str = "public static final String " + token + " = \"" + token + "\";\n";
            buf.append(str);
        }

        checkImageDir();
        pane.setText(buf.toString());
        frame.pack();
        frame.setVisible(true);
    }

    private static void checkImageDir() {
        File[] files = new File("c:\\code\\liveassistant\\client\\resources\\images").listFiles();
        final int no = files != null ? files.length : 0;
        for (int i = 0; i < no; i++) {
            File imageFile = files[i];
            String name = imageFile.getName();

            // Check to see if the name of the file exists
            boolean exists = false;
            Enumeration enumeration = prb.getKeys();
            while (enumeration.hasMoreElements()) {
                String token = (String)enumeration.nextElement();
                String value = prb.getString(token);
                if (value.endsWith(name)) {
                    exists = true;
                }
            }

            if (!exists) {
                System.out.println(imageFile.getAbsolutePath() + " is not used.");
            }
        }
    }

    public static final URL getURLWithoutException(String propertyName) {
        // Otherwise, load and add to cache.
        try {
            final String iconURI = getString(propertyName);
            final URL imageURL = cl.getResource(iconURI);
            return imageURL;
        }
        catch (Exception ex) {
            Log.debug(propertyName + " not found.");
        }
        return null;
    }
}