/**
 * $Revision: $
 * $Date: $
 *
 * Copyright (C) 2006 Jive Software. All rights reserved.
 *
 * This software is published under the terms of the GNU Lesser Public License (LGPL),
 * a copy of which is included in this distribution.
 */

package org.jivesoftware.gateway.transports;

import org.jivesoftware.gateway.resource.GatewayImageRes;
import org.jivesoftware.gateway.resource.GatewayI18nRes;
import org.jivesoftware.sparkimpl.plugin.gateways.transports.Transport;

import javax.swing.Icon;

/**
 *
 */
public class IRCTransport implements Transport {

    private String serviceName;

    public IRCTransport(String serviceName){
        this.serviceName = serviceName;
    }

    public String getTitle(){
        return GatewayI18nRes.getString("title.irc.registration");
    }

    public String getInstructions() {
        return GatewayI18nRes.getString("message.enter.irc");
    }

    public Icon getIcon() {
        return GatewayImageRes.getImageIcon(GatewayImageRes.IRC_TRANSPORT_ACTIVE_IMAGE);
    }

    public Icon getInactiveIcon() {
        return GatewayImageRes.getImageIcon(GatewayImageRes.IRC_TRANSPORT_INACTIVE_IMAGE);
    }

    public String getServiceName() {
        return serviceName;
    }

    public String getName(){
        return "IRC";
    }

    public void setServiceName(String serviceName) {
        this.serviceName = serviceName;
    }
}
